import { PublicKey } from "@solana/web3.js";
import { TransactionBuilder } from "@orca-so/common-sdk";
import { Context, PDA } from "..";
import { IsKycData, ProviderConfigData, UserConfigData, UserKycData } from "../types";
export declare class KycClient {
    ctx: Context;
    pda: PDA;
    constructor(ctx: Context, pda: PDA);
    static getClient(ctx: Context): Promise<KycClient>;
    createProviderConfig(provider: PublicKey, name: string): Promise<TransactionBuilder>;
    deactivateProvider(name: string): Promise<TransactionBuilder>;
    deactivateUser(user: PublicKey): Promise<TransactionBuilder>;
    getProviderConfigByProviderName(providerName: string): Promise<ProviderConfigData>;
    getUserConfig(user: PublicKey): Promise<UserConfigData>;
    getOneUserConfig(userConfig: PublicKey): Promise<UserConfigData>;
    getCurrentUserKyc(user: PublicKey): Promise<UserKycData>;
    getOneUserKyc(userKyc: PublicKey): Promise<UserKycData>;
    isKyc(user: PublicKey): Promise<IsKycData>;
}
