import { PublicKey } from "@solana/web3.js";
import { TransactionBuilder } from "@orca-so/common-sdk";
import { Context, PDA, Gender } from "..";
import { IsKycData, ProviderConfigData, UserConfigData, UserKycData } from "../types";
export declare class ProviderClient {
    ctx: Context;
    pda: PDA;
    nameHashRound: number;
    documentIdHashRound: number;
    dobHashRound: number;
    doeHashRound: number;
    genderHashRound: number;
    constructor(ctx: Context, pda: PDA, nameHashRound: number, documentIdHashRound: number, dobHashRound: number, doeHashRound: number, genderHashRound: number);
    static getClient(ctx: Context, nameHashRound?: number, documentIdHashRound?: number, dobHashRound?: number, doeHashRound?: number, genderHashRound?: number): Promise<ProviderClient>;
    submitKyc(providerName: string, user: PublicKey, salt: string, kycLevel: number, name: string, documentId: string, country: string, dob: Date, doe: Date | null, gender: Gender | null, isExpired: boolean): Promise<TransactionBuilder>;
    updateKyc(providerName: string, user: PublicKey, name: string, documentId: string, country: string, dob: Date, doe: Date | null, gender: Gender | null, isExpired: boolean): Promise<TransactionBuilder>;
    transferKycToken(user: PublicKey, mint: PublicKey): Promise<string>;
    getProviderConfigByProviderName(providerName: string): Promise<ProviderConfigData>;
    getOneProviderConfig(providerConfig: PublicKey): Promise<ProviderConfigData>;
    getUserConfig(user: PublicKey): Promise<UserConfigData>;
    getOneUserConfig(userConfig: PublicKey): Promise<UserConfigData>;
    getCurrentUserKyc(user: PublicKey): Promise<UserKycData>;
    getOneUserKyc(userKyc: PublicKey): Promise<UserKycData>;
    isKyc(user: PublicKey): Promise<IsKycData>;
}
